=== debian/changelog ===
mono (5.18.0.240+dfsg-5) unstable; urgency=medium

  * [cd49e97] Missed one (Closes: #939923)

 -- Jo Shields <joshield@microsoft.com>  Tue, 10 Sep 2019 09:09:48 -0400

mono (5.18.0.240+dfsg-4) unstable; urgency=medium

  [ Marek Safar ]
  * [d8d5d6b] Fixes __MonoCS__ handling of value types

  [ Jo Shields ]
  * [1e58909] Try python3ification (Closes: #937067)
  * [fb709a0] Python3 in debian/control

 -- Jo Shields <joshield@microsoft.com>  Mon, 09 Sep 2019 14:00:35 -0400

mono (5.18.0.240+dfsg-3) unstable; urgency=high

  [ Jo Shields ]
  * [20a7dd0] Don't build docs on s390x, to work around a dumb issue

  [ Neale Ferguson ]
  * [3713407] Fix s390x Outarg_VT (#10632)
    * Fix outarg_vt processing. Fixes #10549
    * Cleanup unused bits and pieces
    * Correct the handling of structures being retuned from a call
    * Restore vtcopy code etc.
    (Closes: #921232)

 -- Jo Shields <joshield@microsoft.com>  Tue, 16 Apr 2019 15:41:50 -0400

mono (5.18.0.240+dfsg-2) unstable; urgency=medium

  * [fcb8084] Add missing libmono-system-native (Closes: #920531)
  * [8b705cf] Don't call cert-sync if it doesn't exist (Closes: #902663)
  * [0514d12] Try fixing kFreeBSD building

 -- Jo Shields <directhex@apebox.org>  Sat, 26 Jan 2019 13:19:06 -0500

mono (5.18.0.240+dfsg-1) unstable; urgency=medium

  [ Jo Shields ]
  * [c67387f] New upstream version 5.18.0.240+dfsg
  * [7a3d16f] Add reference-assemblies-with-csc patch for v4.7.2
  * [5d42c62] Reorder rules so it's possible to override CFLAGS/CXXFLAGS 
    per-arch
  * [c1147ec] Let's not worry about LLVM for now
  * [d6ff03e] Don't override GCC to 5.5 on s390x
  * [e0fb8de] Enable BTLS on ppc64el
  * [c842d23] Use provided mono-api-diff.exe
  * [f262b7e] Install v4.7.2 API
  * [871c1b3] Refreshed symbols
  * [89d55c3] Use langversion 7.2 for tests (7.3 needs Roslyn)
  * [ae548db] Disallow directory traversal (Closes: CVE-2018-1002208)
  * [de5aae0] Switch internal dh_clideps to use ikdasm
  * [b518c84] Add v4.7.2 API to dh_clideps excludes
  * [be0afd7] -fstack-protector-strong breaks s390x on PIC-default gcc. 
    Remove it there. (Closes: #919371)
  * [73b4472] Refreshed clilibs

  [ Neale Ferguson ]
  * [753ee8c] Fix s390x build broken by incorrect specification of the 
    msgfi instuc… (#10026)
    Fix s390x build broken by incorrect specification of the msgfi
    instruction used in MUL_IMM type operations. The instruction had 
    been encoded as its 32-bit counterpart (msfi).
    In addition, the s390x microcode makes the 
    mono_strength_reduction_division unnecessary so this can be bypassed.
    The change to basic.make is just to avoid error messages when 
    basic-profile-check.exe hasn't been built yet.
  * [cb37e0b] Simplify retrieving TLS offset
  * [fecfbf8] Cater for later glibc use of ucontext
  * [cc78fc2] Missing include

 -- Jo Shields <joshield@microsoft.com>  Fri, 18 Jan 2019 12:18:02 -0500

mono (5.16.0.220+dfsg3-2) unstable; urgency=medium

  * No-change rebuild (Closes: #919031)

 -- Jo Shields <directhex@apebox.org>  Sat, 12 Jan 2019 15:01:30 -0500
